// --------------------------------------------------------------------------------------------------------------------
// <copyright file="Metric.cs" company="Reimers.dk">
//   Copyright © Reimers.dk 2006
// </copyright>
// <summary>
//   Defines the Metric type.
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace Reimers.Google.Analytics
{
    /// <summary>
    /// Enumeration of report metrics.
    /// </summary>
    public enum Metric
    {
        bounces = 0,
        entrances = 1,
        exits = 2,
        newVisits = 3,
        pageviews = 4,
        timeOnPage = 5,
        timeOnSite = 6,
        visitors = 7,
        visits = 8,
        adCost = 9,
        adClicks = 10,
        CPC = 11,
        CPM = 12,
        CTR = 13,
        impressions = 14,
        uniquePageviews = 15,
        itemQuantity = 16,
        itemRevenue = 17,
        transactionRevenue = 18,
        transactions = 19,
        transactionShipping = 20,
        transactionTax = 21,
        uniquePurchases = 22,
        searchDepth = 23,
        searchDuration = 24,
        searchExits = 25,
        searchRefinements = 26,
        searchUniques = 27,
        searchVisits = 28,
        goal1Completions = 29,
        goal2Completions = 30,
        goal3Completions = 31,
        goal4Completions = 32,
        goalCompletionsAll = 33,
        goal1Starts = 34,
        goal2Starts = 35,
        goal3Starts = 36,
        goal4Starts = 37,
        goalStartsAll = 38,
        goal1Value = 39,
        goal2Value = 40,
        goal3Value = 41,
        goal4Value = 42,
        goalValueAll = 43
    }
}
